///////////////////////////////////////////////////
//Project 4.08 Piezo Metronome II
int piezo = A11;
int knock = 0;
int redLED = 9;
int SW1 = A2;
long periods;
long beats;
long times[4];
int count = 0;
int playback = 0;
void setup(){
  Serial.begin(9600);
  clearPiezo();
  pinMode(redLED,OUTPUT);
  pinMode(SW1,INPUT);
}
void loop(){
  knock = analogRead(piezo);
  if(knock > 40){
    times[count] = millis();
    digitalWrite(redLED,HIGH);
    delay(50);
    digitalWrite(redLED,LOW);
    count ++;
    while(knock > 20){
      clearPiezo();
      knock = analogRead(piezo);
    }
  }
  if(count==4){
    pinMode(piezo,OUTPUT);
    count = 0; //reset for next time
    periods = 0;
    //calculate periods
    for(int j = 0; j<3; j++){
      //measure the time between beats
      periods = periods + times[j+1] - times[j];     
    }
    periods = periods/3;
    if(periods < 50) periods = 51;
    Serial.print(Beats per Minute = );
    Serial.println(60L*1000L/periods);
    //now play back until SW1 pressed
    while(digitalRead(SW1)==HIGH){    
      //create tone
      digitalWrite(redLED,HIGH);
      piezoTone(2500,50);
      digitalWrite(redLED,LOW);
      delay(periods-50);
    } //end if for SW1 pressed
    //turn piezo back to an input
    while(digitalRead(SW1)==LOW){
      clearPiezo();
    }
  }
}
void clearPiezo(){
  pinMode(piezo,OUTPUT);
  digitalWrite(piezo,LOW);
  delay(1);
  pinMode(piezo,INPUT);
}
void piezoTone(long freq, long duration){
  long aSecond = 1000000;
  long period = aSecond/freq;
  duration = duration*1000;
  duration = duration/period;
  for(long k = 0; k < duration; k++){
    digitalWrite(piezo,HIGH);
    delayMicroseconds(period/2);
    digitalWrite(piezo,LOW);
    delayMicroseconds(period/2);
  }
} 
///////////////////////////////////////////////////
